function F = fitfunc_CEST_jpb_fminsearch2SL_global(initparam)

global freq
global sllist
global sllist_allres
global datainput
global numpts
global chemshift
global restype
global fityn
global dataout
global SLdura
%global SLpow
global chemcenter
global numres

for i = 1:numres
    w1 = sllist_allres{i}*2*pi; %spin lock power
    dataout{i} = zeros(numpts(i), 1); %create calculated data array

    for icount = 1:numpts(i);
        %chemcenter = 19.008;
        specfrq = 150.902406439; %600 MHz
        jch = 0; %always use jch = 0 for methyl CHD2 13C CEST experiment

        if jch > 0;
            jcend = 2;
        else
            jcend = 1;
        end

        %set param values
            R1 = initparam((3*(i-1))+3);
            R2a = initparam((3*(i-1))+4);
            %display(icount)
            R2b = R2a;

        if restype == 0;
            dwab = 0;
            pb = 0;
            pc = 0;
            pa = 1-pb-pc;
            k1 = 0;
            kba = pa*k1/(pa+pb);
            kab = pb*k1/(pa+pb);
        else
            dwab = initparam((3*(i-1))+5);
            pb = initparam(1);
            %pc = 0;
            pa = 1-pb;
            k1 = initparam(2);
            kba = pa*k1/(pa+pb);
            kab = pb*k1/(pa+pb);
        end

        out = 0;

        for jcloop = 1:jcend;
            wrf = freq{i}(icount);
            %set chemical shifts of ground and excited states
            %ground state chem shift set to be observed resonance position
            da = ((chemcenter - chemshift(i))*specfrq+wrf)*2*pi;
            db = da-dwab*specfrq*2*pi;
            if jcloop == 1 && jcend == 2;
                da = da + jch*pi;
                db = db + jch*pi;
            elseif jcloop == 2 && jcend == 2;
                da = da - jch*pi;
                db = db - jch*pi;
            end

            %initial density matrix (+z and -z)
            Ao1  = [0.5 0 0 pa 0 0 pb]'; %E/2 IxG IyG IzG IxE IyE IzE
            Ao2  = [0.5 0 0 -pa 0 0 -pb]'; %E/2 IxG IyG IzG IxE IyE IzE
            %evolution  matrix
            P =[0         0            0            0            0            0            0       ; ...
                0         R2a+kab  da          -w1(icount)          -kba          0            0          ; ...
                0        -da           R2a+kab  0            0           -kba          0            ; ...
                -2*R1*pa  w1(icount)           0            R1+kab  0            0           -kba      ; ...
                0        -kab          0            0            R2b+kba  db          -w1(icount)          ; ...
                0         0           -kab          0           -db           R2b+kba  0         ; ...
                -2*R1*pb  0            0           -kab         w1(icount)           0            R1+kba  ] ;

            eP=expm(-P*SLdura); %SLdura relaxation time
            A1=eP*Ao1;
            Mza1=A1(4); %mag at end of Trelax (+z)
            A2=eP*Ao2;
            Mza2=A2(4); %mag at end of Trelax (-z)
            DMz=(Mza1-Mza2)/(2*pa); %normalzied int (avg +z,-z)
            out = DMz + out;
        end
        if jcend == 2;
            dataout{i}(icount, 1) = out/2;
        else
            dataout{i}(icount, 1) = out;
        end
    end
end

dataout_col = [];
datainput_col = [];

for i = 1:numres
   dataout_col = [dataout_col;dataout{i}];
   datainput_col = [datainput_col;datainput{i}];
end

%residuals
if fityn == 1;
    F = sum((dataout_col - datainput_col).^(2));
elseif fityn == 0;
    F = dataout; %output calculated data
end

end
